# Author: Osborne

# NVRAM Variable Used
# fw_server_in_use	= { 1 | 2 | 3 }
# check_fw_state	= 0: Initial State
#			  1: Failed to retrive the control file
#			  2: Failed to retrive the firmware image
#			  3: Retrived the firmware successfully

# Variable List
model_name=`nvram get model_name`
fw_server1=router-fw1.ftp.netgear.com
fw_server2=router-fw2.ftp.netgear.com
fw_server3=router-fw3.ftp.netgear.com
check_fw_ctrlfile=${model_name}.LatestVersion
fw_current_version=`nvram get fw_version`  # Values: "NA" means North America, "JP" mean
fw_latest_version=
fw_server_specified=
fw_location=
fw_size=
fw_filename=
#OsborneModify Start on August 7, 2006.
line_count=
index=0
label=
fw_sku=`nvram get fw_version | cut -c 7-8`
if [ "${fw_sku}" != "" ]
then
	fw_sku=${model_name}_`nvram get fw_version | cut -c 7-8`
else
	fw_sku=${model_name}
fi
#ObsorneModify End.

# Main Operation
echo check_fw.sh is running..

if [ "$1" = "debug" ]
then
	echo Variable List:
	echo model_name=${model_name}
#OsborneModify Start on August 7, 2006.
	echo fw_sku=${fw_sku}
#ObsorneModify End.
	echo fw_server1=${fw_server1}
	echo fw_server2=${fw_server2}
	echo fw_server3=${fw_server3}
	echo check_fw_ctrlfile=${check_fw_ctrlfile}
	echo fw_current_version=${fw_current_version}
	echo
	echo Command:
	echo wget ftp://${fw_server1}/files/firmware/${check_fw_ctrlfile}
	echo
fi

nvram set check_fw_state=0
nvram set fw_server_in_use=1
nvram unset fw_latest_version
cd /tmp
wget ftp://${fw_server1}/files/firmware/${check_fw_ctrlfile}

if [ "$?" = "0" ]
then
        echo Control File Received from Server 1 Successfully!
else
	nvram set fw_server_in_use=2
	wget ftp://${fw_server2}/files/firmware/${check_fw_ctrlfile}

	if [ "$?" = "0" ]
	then
		echo Control File Received from Server 2 Successfully!
	else
		nvram set fw_server_in_use=3
		wget ftp://${fw_server3}/files/firmware/${check_fw_ctrlfile}

		if [ "$?" = "0" ]
		then
			echo Control File Received from Server 3 Successfully!
		else
			echo Failed to Receive Control File!
			nvram set check_fw_state=1
			exit 1;
		fi
	fi
fi

#OsborneModify Start on August 7, 2006.
#grep ${fw_sku} ./${check_fw_ctrlfile}
#if [ "$?" != "0" ]
#then
#	echo SKU Not Found in Control File!
#	nvram set check_fw_state=1
#	exit 1;
#fi
#OsborneModify End.
# Notice: all environment variables assigned values via sed are appended with a '\r'..
# Solution: Use 'dos2unix' to convert the firmware description file.
dos2unix ./${check_fw_ctrlfile}
#OsborneModify Start on August 7, 2006.
#fw_location=`sed -n '2 p' ./${check_fw_ctrlfile}`
#fw_server_specified=`sed -n '3 p' ./${check_fw_ctrlfile}`
#fw_size=`sed -n '4 p' ./${check_fw_ctrlfile}`
line_count=`wc -l ./${check_fw_ctrlfile} | cut -d. -f 1 | tr -d ' '`

while [ -f ${check_fw_ctrlfile} -a "${index}" -le "${line_count}" -a "${fw_sku}" != "${label}" ]
do
	index=`expr ${index} + 1`
	echo sed -n \'${index} p\' ./${check_fw_ctrlfile} \| cut -d\[ -f 2 \| cut -d\] -f 1 \| tr -d \' \' \| tr -d \'\\t\' > ./check_fw_tmp
	label=`sh ./check_fw_tmp`
done

if [ "${fw_sku}" != "${label}" ]
then
	echo SKU Not Found in Control File!
	nvram set check_fw_state=1
	exit 1;
fi

while [ -f ${check_fw_ctrlfile} -a "${fw_location}" = "" ]
do
	index=`expr ${index} + 1`
	echo sed -n \'${index} p\' ./${check_fw_ctrlfile} \| tr -d \' \' \| tr -d \'\\t\' > ./check_fw_tmp
	fw_location=`sh ./check_fw_tmp`
done

while [ -f ${check_fw_ctrlfile} -a "${fw_server_specified}" = "" ]
do
	index=`expr ${index} + 1`
	echo sed -n \'${index} p\' ./${check_fw_ctrlfile} \| tr -d \' \' \| tr -d \'\\t\' > ./check_fw_tmp
	fw_server_specified=`sh ./check_fw_tmp`
done

while [ -f ${check_fw_ctrlfile} -a "${fw_size}" = "" ]
do
	index=`expr ${index} + 1`
	echo sed -n \'${index} p\' ./${check_fw_ctrlfile} \| tr -d \' \' \| tr -d \'\\t\' > ./check_fw_tmp
	fw_size=`sh ./check_fw_tmp`
done

if [ ! -f ${check_fw_ctrlfile} ]
then
	echo Procedure Stopped by CGI!
	exit 1
fi
rm ./check_fw_tmp
rm ./${check_fw_ctrlfile}
#OsborneModify End.
fw_filename=`basename ${fw_location}`
fw_latest_version=`basename ${fw_location} | cut -dv -f 2 | cut -dV -f 2 | cut -d. -f 1-3`
# Example - FW filename: wnr854t_v1.1.15NA.img -> fw_latest_version: 1.1.15NA
nvram set fw_latest_version=${fw_latest_version}
nvram set fw_filename=${fw_filename}
nvram set fw_size=${fw_size}
nvram set fw_server_specified=${fw_server_specified}
nvram set fw_location=${fw_location}

echo fw_check.sh is done.
nvram set check_fw_state=3
exit 0

